con
  _CLKMODE      = XTAL1 + PLL8X                        
  _XINFREQ      = 10_000_000

  ' Chip select pin / bitmask
  CS_     = 18
  CS_pin  = 1<<18
  ' Register select
  RS_     = 9
  RS_pin  = 1<<9
  ' Write
  WR_     = 17
  WR_pin  = 1<<17
  ' Read
  RD_     = 15
  RD_pin  = 1<<15
  ' Reset
  RES_    = 16
  RES_PIN = 1<<16

  SDpinBase = 24

  BUF_SIZE = 2048
  
  BMP_BASE = $0000_0000 

obj
  lcd: "SPFD5408driverC"
  sdfat: "fsrwB"
  font: "Font8x12"

var
  long bigBuffer1[BUF_SIZE]
  'long bigBuffer2[BUF_SIZE]

  long route, evenodd
'  word pAdr[30]
  long startT, endT, correctT, combuf, bmpfound
  byte flname[13]
  
pub main | ferb, xy, x ,y, mask, pic
  ' init the SD card driver
  x:=0
  
  startT:=cnt
  endT:=cnt
  correctT:=endT-startT
  
  mask:=lcd.start( RS_, CS_, RD_, WR_, RES_ )
  Init
  ' Clearscreen
  lcd.exec1( lcd#CMD_HOME, $00ef )
  lcd.exec1( lcd#CMD_CLEAR, 0 )

  sdfat.mount( SDpinBase, lcd.getCmdBuf, mask )
  'combuf := sdfat.getComBuf

  
  ' Color cycle
    x := sdfat.popen( string("Menu1.bmp"), "r" )
    x := 19200
    pic:=0
    sdfat.pread(@bigBuffer1, 54)
    repeat while x>0
      sdfat.pread( @bigBuffer1, 2048 )
      repeat y from 0 to 3
        sdfat.vwMemCopy( $4000 + pic + 512*y + xy, @bigBuffer1+512*y, 512)
      x-=2048
      xy+=2048

    x := sdfat.popen( string("Menu2.bmp"), "r" )
    x := 19200
    pic+=19456
    xy:=0
    sdfat.pread(@bigBuffer1, 54)
    repeat while x>0
      sdfat.pread( @bigBuffer1, 2048 )
      repeat y from 0 to 3
        sdfat.vwMemCopy( $4000 + pic + 512*y + xy, @bigBuffer1+512*y, 512)
      x-=2048
      xy+=2048

    x := sdfat.popen( string("Menu3.bmp"), "r" )
    x := 19200
    pic+=19456
    xy:=0
    sdfat.pread(@bigBuffer1, 54)
    repeat while x>0
      sdfat.pread( @bigBuffer1, 2048 )
      repeat y from 0 to 3
        sdfat.vwMemCopy( $4000 + pic + 512*y + xy, @bigBuffer1+512*y, 512)
      x-=2048
      xy+=2048
    
    x := sdfat.popen( string("Menu4.bmp"), "r" )
    x := 19200
    pic+=19456
    xy:=0
    sdfat.pread(@bigBuffer1, 54)
    repeat while x>0
      sdfat.pread( @bigBuffer1, 2048 )
      repeat y from 0 to 3
        sdfat.vwMemCopy( $4000 + pic + 512*y + xy, @bigBuffer1+512*y, 512)
      x-=2048
      xy+=2048


pub PrintChar( x, y, col, char ) | startBit, pixels, adr, xo, yo
  adr := $8000 + char*32

  startBit := 1<<(30 + (char & $1))
  repeat yo from 0 to 31
    pixels := long[ $8000 + (char&$fe)<<6 + yo*4]
    repeat xo from 0 to 15
      if pixels & startBit
        Plot( 239-(x-xo), y-yo, col )
      pixels := pixels<<2 
      
pub Plot( x, y, col )
  'cmd( $2000 )
  'data( x<<8 )
  'cmd( $2100 )
  'data( (y&$ff)<<8 + (y>>8)&$ff )
  'cmd( $2200 )
  lcd.exec1( lcd#CMD_HOME, y<<8+x )
  lcd.exec1( lcd#CMD_PIXELOUT, col )
  
pub Home
  lcd.exec1( lcd#CMD_HOME, $000ef )
  'cmd( $2000 )
  'data( $ef00 )

  'cmd( $2100 )
  'data( 0 )

  'cmd( $2200 )

pri cmd( command ) | col
  lcd.exec1( lcd#CMD_CMDOUT, command )
  waitcnt( 500+cnt )

pri data( val ) | col
  lcd.exec1( lcd#CMD_DATAOUT, val )
  ' waitcnt( 500+cnt )

pri pixel( col )
  lcd.exec1( lcd#CMD_PIXELOUT, col )

pub Init | col
  cmd( $00 )
  data( $0100 )
  cmd( $0100 )
  data( 0 )
  cmd( $0200 )
  data( $0107 )
  cmd( $0300 )
  data( $20C0 )
  cmd( $0400 )
  data( 0 )
  cmd( $0800 )
  data( $0702 )
  cmd( $0900 )
  data( 0 )
  cmd( $0a00 )
  data( 0 )
  cmd( $0c00 )
  data( 0 )
  cmd( $0d00 )
  data( 0 )
  cmd( $0f00 )
  data( 0 )
  cmd( $0700 )
  data( $0101 )

  waitcnt( clkfreq/5 +cnt )
  
  cmd( $1000 )
  data( $B010 )
  cmd( $1100 )
  data( $0700 )
  cmd( $0700 )
  data( $0100 )
  cmd( $1200 )
  data( $3B01 )
  cmd( $1300 )
  data( $000B )

  waitcnt( clkfreq/5 +cnt )

  cmd( $2900 )
  data( $1200 )
  cmd( $2A00 )
  data( $9500 )

  waitcnt( clkfreq/50 + cnt )

  cmd( $3000 )
  data( $0a00 ) 
  cmd($3100)     ' Gamma Control 2
  data($2613)      ' Page 32, SPFD5408B Datasheet  
  cmd($3200)     ' Gamma Control 3
  data($290A)      ' Page 32, SPFD5408B Datasheet  
  cmd($3300)     ' Gamma Control 4
  data($0A29)      ' Page 32, SPFD5408B Datasheet  
  cmd($3400)     ' Gamma Control 5
  data($1326)      ' Page 32, SPFD5408B Datasheet  
  cmd($3500)     ' Gamma Control 6
  data($0A0A)      ' Page 32, SPFD5408B Datasheet  
  cmd($3600)     ' Gamma Control 7
  data($031E)      ' Page 32, SPFD5408B Datasheet  
  cmd($3700)     ' Gamma Control 8
  data($1E03)      ' Page 32, SPFD5408B Datasheet 
  cmd($3800)     ' Gamma Control 9
  data($0607)      ' Page 32, SPFD5408B Datasheet  
  cmd($3900)     ' Gamma Control 10
  data($0303)      ' Page 32, SPFD5408B Datasheet  
  cmd($3A00)     ' Gamma Control 11
  data($040E)      ' Page 32, SPFD5408B Datasheet  
  cmd($3B00)     ' Gamma Control 12
  data($010E)      ' Page 32, SPFD5408B Datasheet  
  cmd($3C00)     ' Gamma Control 13
  data($0E01)      ' Page 32, SPFD5408B Datasheet  
  cmd($3D00)     ' Gamma Control 14
  data($0E04)      ' Page 32, SPFD5408B Datasheet  
  cmd($3E00)     ' Gamma Control 15
  data($0303)      ' Page 32, SPFD5408B Datasheet  
  cmd($3F00)     ' Gamma Control 16
  data($0706)      ' Page 32, SPFD5408B Datasheet  

  ' the data calls that are commented out came from demo-code, the actual
  ' calls use parameters as given in init-sequence of datasheet
  cmd($5000)     ' Window Horizontal RAM Address Start (R50h)
  data($0000)      ' Page 32, SPFD5408B Datasheet
  cmd($5100)     ' Window Horizontal RAM Address End (R51h)
  data($EF00)      ' Page 32, SPFD5408B Datasheet
  cmd($5200)     ' Window Vertical RAM Address Start (R52h)
  data($0000)      ' Page 33, SPFD5408B Datasheet
  cmd($5300)     ' Window Vertical RAM Address End (R53h)
  data($3F01)      ' Page 33, SPFD5408B Datasheet

  cmd($6000)     ' Driver Output Control (R60h)
  data($0027)      ' Page 33, SPFD5408B Datasheet
  cmd($6100)     ' Driver Output Control (R61h)
  data($0100)      ' Page 35, SPFD5408B Datasheet

  cmd($6A00)     ' Vertical Scroll Control (R6Ah)
  data($0000)      ' Page 35, SPFD5408B Datasheet

  cmd($8000)     ' Display Position - Partial Display 1 (R80h)
  data($0000)      ' Page 35, SPFD5408B Datasheet
  cmd($8100)     ' RAM Address Start - Partial Display 1 (R81h)
  data($0000)      ' Page 35, SPFD5408B Datasheet
  cmd($8200)     ' RAM Address End - Partial Display 1 (R82h)
  data($0000)      ' Page 36, SPFD5408B Datasheet
  cmd($8300)     ' Display Position - Partial Display 2 (R83h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 
  cmd($8400)     ' RAM Address Start - Partial Display 2 (R84h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 
  cmd($8500)     ' RAM Address End - Partial Display 2 (R85h)
  data($0000)      ' Page 36, SPFD5408B Datasheet 

  cmd($9000)     ' Panel Interface Control 1 (R90h)
  data($1300)
  cmd($9200)     ' Panel Interface Control 2 (R92h)
  data($0000)      ' Page 37, SPFD5408B Datasheet 
  cmd($9300)     ' Panel Interface control 3 (R93h)
  data($0301)      ' Page 38, SPFD5408B Datasheet 
  cmd($9500)     ' Panel Interface control 4 (R95h)
  data($1001) 
  cmd($9700)     ' Panel Interface Control 5 (R97h)
  data($0000)      ' Page 40, SPFD5408B Datasheet
  cmd($9800)     ' Panel Interface Control 6 (R98h)
  data($0000)      ' Page 41, SPFD5408B Datasheet

  cmd( $f000 )
  data( $0854 )
  cmd( $f300 )
  data($1000)
  cmd($f400)
  data($1100)
  cmd($f000)
  data($0000)
  
  cmd( $0700 )
  data( $7301 )

  ' dira:=0

dat
zahl long $1234_5678