con
  _CLKMODE      = XTAL1 + PLL8X                        
  _XINFREQ      = 10_000_000

  ' Chip select pin / bitmask
  CS_     = 22
  CS_pin  = 1<<22
  ' Register select
  RS_     = 9
  RS_pin  = 1<<9
  ' Write
  WR_     = 21
  WR_pin  = 1<<21
  ' Read
  RD_     = 15
  RD_pin  = 1<<15
  ' Reset
  RES_    = 20
  RES_PIN = 1<<20

  SDpinBase = 16

  BUF_SIZE = 2048
  
  BMP_BASE = $0000_0000 
  KeyPinBase      = 10

  
obj
  lcd: "SPFD5408driverC"
  sdfat: "fsrwB"
  font: "Font8x12"
  kb: "keyboard"

var
  long bigBuffer1[BUF_SIZE]
  'long bigBuffer2[BUF_SIZE]

  long route, evenodd
  word pAdr[30]
  long startT, endT, correctT, combuf, bmpfound
  byte flname[13]
  
pub main | ferb, xy, x ,y, mask, key
  kb.start(KeyPinBase+1,KeyPinBase)

  mask:=lcd.start( RS_, CS_, RD_, WR_, RES_ )
  Init
  ' Clearscreen
  lcd.exec1( lcd#CMD_HOME, $00ef )
  lcd.exec1( lcd#CMD_CLEAR, 0 )

  dira[24]:=1
  outa[24]:=1

  key := 0
  endT := cnt + clkfreq*30
  repeat while endT<>0 and (endT-cnt)<0
    if kb.gotkey
      key := kb.getKey - $30
      endT:=0
  'key := kb.getKey
  'key := key-$30

  pAdr[ x++ ]:=string("bar_01.bm")
  pAdr[ x++ ]:=string("bar_02.bm")
  pAdr[ x++ ]:=string("bar_03.bm")
  pAdr[ x++ ]:=string("bar_04.bm")
  pAdr[ x++ ]:=string("bar_05.bm")
  pAdr[ x++ ]:=string("bar_06.bm")
  pAdr[ x++ ]:=string("bar_07.bm")
  pAdr[ x++ ]:=string("bar_08.bm")
  pAdr[ x++ ]:=string("bar_09.bm")
  pAdr[ x++ ]:=string("bar_10.bm")
  pAdr[ x++ ]:=string("bar_11.bm")
  pAdr[ x++ ]:=string("bar_12.bm")
    
  ' init the SD card driver
  x:=0
  
  startT:=cnt
  endT:=cnt
  correctT:=endT-startT
  
  sdfat.mount( SDpinBase )', lcd.getCmdBuf, mask )
  'combuf := sdfat.getComBuf

  ' Scan the directory for .bmp files
  startT:=cnt
  sdfat.opendir
  bmpfound:=0
  repeat until sdfat.nextfile( @flname )
    y:=0
    repeat until flname[y++] == "." or y==13
    if flname[y]=="B" and flname[y+1]=="M" and flname[y+2]=="P"   
      sdfat.vwMemCmpCopy( BMP_BASE + bmpfound<<4, @flname, 13 )
      bmpfound++
  sdfat.vMemFlush
  endT:=cnt
  PrintMs
  wait( key )

  ' read some data from SD using the SD-LCD link
  x:=sdfat.getSwap<<16 + 128
  startT:=cnt
  lcd.exec1( lcd#CMD_HOME, $000ef )
  lcd.exec1( lcd#CMD_CMDOUT, $2200 )
  repeat y from 0 to 449
    sdfat.checkSektor( $1d_0000 + y<<9 )
    lcd.exec1( lcd#CMD_COPY, x) '1024) )    
  endT:=cnt
  PrintMs
  wait( key )

  
  ' Color cycle
  ferb:=0
  ' route:= %00000000000000
  route:= %11111111111111
  repeat
    ' Clear the screen 30 times with differnet colors and
    ' see how long that takes
    if route & %10000
      startT := cnt
      repeat 30
        lcd.exec1( lcd#CMD_HOME, $00ef )
        lcd.exec1( lcd#CMD_CLEAR, ferb )
        ferb:=(ferb+$2f1a0c)
      endT := cnt
      PrintMs
      wait( key )

    ' Plot some lines by setting pixels
    if route & %100000
      repeat xy from 0 to 239
        Plot( xy, xy, $ffffff )
        Plot( 239-xy, xy, $ffffff )

    if route & %10000000
      repeat xy from 0 to 149
        x:=xy//15
        y:=xy/15
        PrintChar( x*16,100+y*32, $ffff00+y*25, xy )
       
      wait( key )

    Scroll


    ' Plot a lot of lines using Chips line drawing algo
    if route & %1000000
      repeat evenodd from 0 to 15
        lcd.setCol( evenodd, $000010 * evenodd )
      lcd.exec1( lcd#CMD_CPYCOLTAB, 15 )
      repeat xy from 0 to 312 step 3
        lcd.exec1( lcd#CMD_ACTCOL, xy/3 )
        lcd.exec2( lcd#CMD_LINE, (xy<<8)+ 10, ((312-xy)<<8)+230 )
      repeat evenodd from 0 to 15
        lcd.setCol( evenodd, $100000 * evenodd )
      lcd.exec1( lcd#CMD_CPYCOLTAB, 15 )
      repeat xy from 0 to 237 step 3
        lcd.exec1( lcd#CMD_ACTCOL, xy/3 )
        lcd.exec2( lcd#CMD_LINE, xy, 312<<8+237-xy )
      wait( key )
     
    ' Loop over all BMP-files with 320x240 resolution
    if route & %100
      PicLoop
      wait( key )

    ' Pic in pic, show the 2 pictures as subwindow
    if route & %1000
      MiniPic
      wait( key )

    ' show the differnece in low color and high color mode
    if route & %10
      LowRainbow(0)
      rainbow(0)
      waitcnt( clkfreq*5+cnt )
      LowRainbow(1)
      rainbow(1)
      'LowRainbow(2)
      'rainbow(2)
      wait( key )

    ' show low color pictures. The first one is transferred to display
    ' directly by SDSPIPASM
    if route & %1
      lcd.exec1( lcd#CMD_CMDOUT, $0300 )
      lcd.exec1( lcd#CMD_DATAOUT, $2040 )
      x := sdfat.popen( string("psst.img"), "r" )
      startT:=cnt
      lcd.exec1( lcd#CMD_HOME, $000ef )
      lcd.exec1( lcd#CMD_CMDOUT, $2200 )
      'repeat y from 0 to 449
      '  sdfat.copyblock( x+y, 1 )
      sdfat.copyblock( x, 300 )
      endT:=cnt
      PrintMs
      wait( key )
       
      LowColPic(string("springer.img"))
      LowColPic(string("bee.img"))
      LowColPic(string("ring.img"))
      LowColPic(string("home.img"))
      LowColPic(string("pink.img"))
      LowColPic(string("psst.img"))

    ' Test for a self-defined font (currently 4 colors)
    if route & %1000000000
      OwnFont( 10,50,string("ABCBABACC") )
      wait( key )
      
    ' Put some 16 color icons on display
    if route & %100000000
      repeat evenodd from 0 to 15
        lcd.setCol( evenodd, $000010 * evenodd )'  + $100000 * (15-evenodd) )
      lcd.exec1( lcd#CMD_CPYCOLTAB, 15 )

      xy:=0

      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff

      repeat 30
        bigBuffer1[xy++] := $ffeeddcc
        bigBuffer1[xy++] := $bbaa9988
        bigBuffer1[xy++] := $77665544
        bigBuffer1[xy++] := $3322110f
        
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff
      bigBuffer1[xy++] := $ffffffff

      repeat xy from 0 to 31
        SetBufPix( xy, xy, 8 )

      startT:=cnt
      repeat y from 0 to 200 step 32
        repeat x from 0 to 200 step 32
          Icon( x, y, 32, 32, @bigBuffer1 )  
      endT:=cnt
      PrintMs
      wait( key )

    if route & %10000000000
      ' woman.bmp where header has been removed
      ' transfer to display directly by SDSPIQASM
      x := sdfat.popen( string("womanrip.bm"), "r" )
      startT:=cnt
      lcd.exec1( lcd#CMD_HOME, $000ef )
      lcd.exec1( lcd#CMD_CMDOUT, $2200 )
      'repeat y from 0 to 449
      '  sdfat.copyblock( x+y, 1 )
      sdfat.copyblock( x, 450 )
      endT:=cnt
      PrintMs
      wait( key )
     
    
    if route & %100000000000
      ' Menu
      printIt := 0
      PrintPic( string("Menu_bck.bm"), 230400, $000ef )
      printIt := 1
      'lcd.exec2( lcd#CMD_SETWIN, $00d70010, $00300000 )
      'lcd.exec1( lcd#CMD_HOME, $10<<8 + $d7 )
      'lcd.exec1( lcd#CMD_CMDOUT, $2200 )
      'sdfat.copyblock( $4000>>9+520, 38 )
      'lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
      startT:=cnt
      PrintMenuEntry( 0, 20, 50 )
      PrintMenuEntry( 1, 20, 100 )
      PrintMenuEntry( 2, 20, 150 )
      PrintMenuEntry( 3, 20, 200 )
      endT:=cnt
      PrintMs
      wait( key )

    if route & %1000000000000
      ' Menu2
      printIt:=0
      PrintPic( string("SHCback.bm"), 230400, $000ef )
      wait( key )
      ScrollIconBar(203, 45)
      wait( key )
    
    ' Clock
    printIt:=0
    PrintPic( string("SHCbak2.bm"), 230400, $000ef )
    wait( key )
    Status
    wait( key )
    Clock
    wait( key )
    printIt:=1
    
     

    ' lcd.exec1( lcd#CMD_HOME, $00ef )
    ' lcd.exec1( lcd#CMD_CMDOUT, $2200 )
    ' startT := cnt
    ' lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + BUF_SIZE )
    ' lcd.exec1( lcd#CMD_HOME, $00ef )
    ' endT := cnt

    ' lcd.exec1( lcd#CMD_HOME, $00ef )
    ' lcd.exec1( lcd#CMD_CLEAR, ferb )

    ' PrintMS

    ' waitcnt( clkfreq*5+cnt )

pub wait( forwhat )
  if forwhat == 0
    waitcnt( clkfreq*5+cnt )

  if forwhat == 1
    kb.newKey


dat time byte 2,1,3,2
    dp   byte "3_d.bm",0
    ndp  byte "3_x.bm",0
    
pub Status
    printItAnyway:=1
    lcd.exec2( lcd#CMD_SETWIN, $00210002, $00140003 )
    repeat 2
      waitcnt( clkfreq +cnt )
      PrintPic( string("bat075.bm"),1728, $03<<8+$21 )
      waitcnt( clkfreq +cnt )
      PrintPic( string("bat050.bm"),1728, $03<<8+$21 )
      waitcnt( clkfreq +cnt )
      PrintPic( string("bat025.bm"),1728, $03<<8+$21 )
      waitcnt( clkfreq +cnt )
      PrintPic( string("bat010.bm"),1728, $03<<8+$21 )
      waitcnt( clkfreq +cnt )
      PrintPic( string("bat025.bm"),1728, $03<<8+$21 )
      waitcnt( clkfreq +cnt )
      PrintPic( string("bat050.bm"),1728, $03<<8+$21 )
      waitcnt( clkfreq +cnt )
      PrintPic( string("bat075.bm"),1728, $03<<8+$21 )
      waitcnt( clkfreq +cnt )
      PrintPic( string("bat100.bm"),1728, $03<<8+$21 )
    waitcnt( clkfreq +cnt )
    lcd.exec2( lcd#CMD_SETWIN, $00380025, $00140003 )
    PrintPic( string("AntOn.bm"),1080, $03<<8+$38 )
    lcd.exec2( lcd#CMD_SETWIN, $004a003b, $00140003 )
    PrintPic( string("TimOn.bm"),864, $03<<8+$4a )
    printItAnyway:=0
    lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
    
    

pub Clock | end
  printItAnyway:=1
  printIt:=0
  time[0]:=5
  time[1]:=1
  time[2]:=3
  time[3]:=2
  bytemove( @flname, @digName, 7 )

  repeat until end
    time[0]:=(time[0]+1)//10
    if time[0]==0
      time[1]:=(time[1]+1)//6
      if time[1]==0
        time[2]:=(time[2]+1)//10
        if time[2]==0
          time[3]:=(time[3]+1)//3
    if time[3]==2 and time[2]==4
      end:=1

    lcd.exec2( lcd#CMD_SETWIN, $006d005e, $00440014 )
    PrintPic( @dp,2304, $14<<8+$6d )
    waitcnt( clkfreq>>2 + cnt )
    lcd.exec2( lcd#CMD_SETWIN, $006d005e, $00440014 )
    PrintPic( @ndp,2304, $14<<8+$6d )
    waitcnt( clkfreq>>2 + cnt )
      
    ShowTime
      
  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
  printItAnyway:=0
  printIt:=1      

'dat oldTime long $ffff
dat digName byte "5_0.bm",0,0
dat digs    byte "0123456789",0,0

pub ShowTime | cpy, pos, pos2, dig
  'cpy:=time
  pos:=5
  pos2:=0
  repeat while pos>0
    flname[0]:=digs[ pos ]
    case pos
      5:
        lcd.exec2( lcd#CMD_SETWIN, $003c001d, $00440014 )
        cpy:=$14<<8+$3c
      4:
        lcd.exec2( lcd#CMD_SETWIN, $005c003d, $00440014 )
        cpy:=$14<<8+$5c
      2:
        lcd.exec2( lcd#CMD_SETWIN, $008c006d, $00440014 )
        cpy:=$14<<8+$8c
      1:
        lcd.exec2( lcd#CMD_SETWIN, $00ac008d, $00440014 )
        cpy:=$14<<8+$ac

    flname[2]:= digs[ time[pos2] ]
    PrintPic( @flname,4608, cpy )

    pos2++
    pos--
    if pos==3
      pos--

  'lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
  'oldTime:=cpy

pub ScrollIconBar( x, y )  | f, rd, i, sektor
  lcd.exec2( lcd#CMD_SETWIN, $00ef00c0, $010e000a )
  printItAnyway:=1
  printIt:=0
  repeat f from 0 to 11
    PrintPic( pAdr[ f ],37584, $0a<<8+$ef )
  waitcnt( clkfreq*5 + cnt )
  repeat f from 11 to 0
    PrintPic( pAdr[ f ],37584, $0a<<8+$ef )

  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
  printItAnyway:=0
  printIt:=1

  'lcd.exec2( lcd#CMD_SETWIN, (x+36)<<16+x, (320-y)<<16 + (320-y-260) )
  '====================================================================
  'lcd.exec1( lcd#CMD_HOME, $0a<<8+$ef )
  'repeat f from 0 to 11
  '  lcd.exec1( lcd#CMD_CMDOUT, $2200 )
  '  sektor:=sdfat.popen(pAdr[f], "r")
  '  sdfat.pread(@bigBuffer1, 54)
  '  rd:=37584
  '  i:=0
  '  repeat while rd>0
  '    sdfat.readblock( sektor+i++, @bigBuffer1)
  '    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#128)) '512))
  '    rd := rd - constant( 512 )'*4 )
         
  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )

pub PrintMenuEntry( men, x, y )
  lcd.exec2( lcd#CMD_SETWIN, (x+199)<<16+x, (320-y-1)<<16 + (320-y-32) )
  lcd.exec1( lcd#CMD_HOME, (320-y-32)<<8 + x+200 )
  lcd.exec1( lcd#CMD_CMDOUT, $2200 )
  sdfat.copyblock( $4000>>9+men*38+520, 38 )
  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )

pub Scroll | y
  lcd.exec1( lcd#CMD_HOME, $000ef )
  repeat y from 0 to 320
    lcd.exec1( lcd#CMD_CMDOUT, $6a00)
    lcd.exec1( lcd#CMD_DATAOUT, ((y&$ff)<<8)+((y>>8)&$01) )
    'lcd.exec1( lcd#CMD_HOME, $000ef )
    lcd.exec1( lcd#CMD_CMDOUT, $2200 )
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + 180) '1024) )
    
    waitcnt( clkfreq/200+cnt )

  lcd.exec1( lcd#CMD_CMDOUT, $6a00)
  lcd.exec1( lcd#CMD_DATAOUT, 0 )

pub OwnFont(x,y,str) | cp, cAdr, line, scan, pixOut
  cp := 0
  repeat while byte[str][cp]
    cAdr := font.getChar( byte[str][cp++] )
     
    repeat line from 0 to 11
      scan := word[cAdr][line]
      repeat pixOut from 0 to 7
        lcd.exec1( lcd#CMD_HOME, (y-line)<<8+ 240-(x+pixOut+(cp*10)) )
        lcd.exec1( lcd#CMD_CMDOUT, $2200 )
        'lcd.exec1( lcd#CMD_PIXELOUT, $ffffff )
        case (scan & %1100000000000000)
          %0000000000000000:
            lcd.exec1( lcd#CMD_PIXELOUT, $3333ff )
          %0100000000000000:
            lcd.exec1( lcd#CMD_PIXELOUT, $00cccc )
          %1000000000000000:
            lcd.exec1( lcd#CMD_PIXELOUT, $aa00aa )
          %1100000000000000:
            lcd.exec1( lcd#CMD_PIXELOUT, $aaFFFF )
        scan:=scan<<2
            
  
pub Icon(x,y,b,h, buffer)
  lcd.exec2( lcd#CMD_SETWIN, ((x+b-1)<<16)+x, ((y+h-1)<<16)+y )
  lcd.exec1( lcd#CMD_HOME, y<<8+x+b-1 )
  lcd.exec1( lcd#CMD_COPY16, (buffer << 16) + b*h/8 )
  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )

pub SetBufPix(x,y,col)
  bigBuffer1[y*4+(x>>3)//4] := bigBuffer1[y*4+(x>>3)//4] & !($f0000000>>((x&7) *4)) | (col&15)<<((7-(x&7))*4)
  
pub rainbow(k) | i, j, r, g, b
  'lcd.exec1( lcd#CMD_HOME, $36000 )
  Home

  repeat i from 0 to 319
    repeat j from 0 to 239
      if k==0
        r:=j*106/100 ' & $ff
        g:=i*100/125
        b:=0' ((255-r+255-g)& $1ff)>>1
      if k==1
        r:=j*106/100 ' & $ff
        g:=0
        b:=i*100/125
      if k==2
        r:=i*100/125 ' & $ff
        g:=i*100/125
        b:=i*100/125
      
      lcd.exec1( lcd#CMD_PIXELOUT, b +g<<8+r<<16 )
    
pub LowRainbow(k) | i, j, r, g, b
  lcd.exec1( lcd#CMD_CMDOUT, $0300 )
  lcd.exec1( lcd#CMD_DATAOUT, $2040 )
  'lcd.exec1( lcd#CMD_HOME, $36000 )
  Home

  repeat i from 0 to 319
    repeat j from 0 to 239
      if k==0
        r:=j/10
        b:=0
        g:=i/5 'j*100/375
      if k==1
        r:=j/10
        b:=i/10
        g:=0
      if k==2
        r:=i/10
        b:=i/10
        g:=i/5
      lcd.exec1( lcd#CMD_DATAOUT, b<<3 + (g&56)>>3 + (g&7)<<13 + r<<8 )

  lcd.exec1( lcd#CMD_CMDOUT, $0300 )
  lcd.exec1( lcd#CMD_DATAOUT, $20C0 )
  waitcnt( clkfreq*5+cnt )
    
pub LowColPic(fname) | rd, sektor, i
  lcd.exec1( lcd#CMD_CMDOUT, $0300 )
  lcd.exec1( lcd#CMD_DATAOUT, $2040 )

  ' sdfat.mount( SDpinBase )
  sektor := sdfat.popen(fname, "r")
  ' sdfat.pread(@bigBuffer, 54)

  lcd.exec1( lcd#CMD_HOME, $000ef )

  rd:=153604
  startT := cnt
  i:=0
  repeat while rd>0
    'sdfat.pread(@bigBuffer1, constant(BUF_SIZE*4))
    'lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#BUF_SIZE))
    'rd := rd - constant( BUF_SIZE*4 )
    sdfat.readblock( sektor+i++, @bigBuffer1)
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#128)) '512))
    rd := rd - constant( 512 )'*4 )

  endT := cnt

  PrintMs
     
  sdfat.pclose
    
  lcd.exec1( lcd#CMD_CMDOUT, $0300 )
  lcd.exec1( lcd#CMD_DATAOUT, $20C0 )
  waitcnt( clkfreq*5+cnt )

pub MiniPic
  lcd.exec2( lcd#CMD_SETWIN, $008f0010, $00900010 )
  printItAnyway:=1
  PrintPic( string("orange.bmp"),49152, $10<<8+$8f )
  waitcnt( clkfreq*5+cnt )
  PrintPic( string("eye2.bmp"),49152, $10<<8+$8f )
  waitcnt( clkfreq*5+cnt )
  lcd.exec2( lcd#CMD_SETWIN, 239<<16, 319<<16 )
  printItAnyway:=0

pub PicLoop | i
  i:=0
  repeat i from 0 to bmpfound-1
    sdfat.vrMemCopy( BMP_BASE + i<<4, @flname, 13 )
    if PrintPic( @flname, 230400, $000ef )
      waitcnt( clkfreq*5+cnt )
    
pub PrintPic( fname, size, pos ) | c, col, pix, rd
  'sdfat.mount( SDpinBase )
  sdfat.popen(fname, "r")
  sdfat.pread(@bigBuffer1, 54)

  if not(printItAnyway) and not(byte[@bigBuffer1][18]==$f0 and byte[@bigBuffer1][22]==$40 and byte[@bigBuffer1][23]==$01)
    sdfat.pclose
    return 0

  lcd.exec1( lcd#CMD_HOME, pos )

  rd:=size
  startT := cnt
  repeat while rd>0
    sdfat.pread(@bigBuffer1, constant( BUF_SIZE*4) )
    lcd.exec1( lcd#CMD_COPY, (@bigBuffer1)<<16 + ((rd/4)<#BUF_SIZE))
    rd := rd - constant( BUF_SIZE*4 )
    'if rd>0
      'sdfat.pread(@bigBuffer2, constant( BUF_SIZE*4 ) )
      'lcd.exec1( lcd#CMD_COPY, (@bigBuffer2)<<16 + ((rd/4)<#BUF_SIZE))
      'rd := rd - constant( BUF_SIZE*4 )
  endT := cnt

  if printIt
    PrintMs
       
  sdfat.pclose
  return 1

pub PrintInt(x,y,val) | count, rest
  repeat while val>0
    rest := val//10 + $30
    val:=val/10
    PrintChar( x-count*16, y, $ffffff, rest )
    count++

pub PrintMs | count, rest, val
  val := ( endT - startT - correctT )/8000
  count := 0

  PrintChar( 210-count++*16, 50, $ffffff, "s" )
  PrintChar( 210-count++*16, 50, $ffffff, "m" )
   
  repeat while val>0
    rest := val//10 + $30
    val:=val/10
    PrintChar( 210-count*16, 50, $ffffff, rest )
    count++
    if count==3
      PrintChar( 210-count*16, 50, $ffffff, "," )
      count++

pub TestPin( pinNo )
  dira:=1<<pinNo
  repeat
    outa[pinNo]~
    outa[pinNo]~~


pub PrintChar( x, y, col, char ) | startBit, pixels, adr, xo, yo
  adr := $8000 + char*32

  startBit := 1<<(30 + (char & $1))
  repeat yo from 0 to 31
    pixels := long[ $8000 + (char&$fe)<<6 + yo*4]
    repeat xo from 0 to 15
      if pixels & startBit
        Plot( 239-(x-xo), y-yo, col )
      pixels := pixels<<2 
      
pub Plot( x, y, col )
  'cmd( $2000 )
  'data( x<<8 )
  'cmd( $2100 )
  'data( (y&$ff)<<8 + (y>>8)&$ff )
  'cmd( $2200 )
  lcd.exec1( lcd#CMD_HOME, y<<8+x )
  lcd.exec1( lcd#CMD_PIXELOUT, col )
  
pub Home
  lcd.exec1( lcd#CMD_HOME, $000ef )
  'cmd( $2000 )
  'data( $ef00 )

  'cmd( $2100 )
  'data( 0 )

  'cmd( $2200 )

pri cmd( command ) | col
  lcd.exec1( lcd#CMD_CMDOUT, command )
  waitcnt( 500+cnt )

pri data( val ) | col
  lcd.exec1( lcd#CMD_DATAOUT, val )
  ' waitcnt( 500+cnt )

pri pixel( col )
  lcd.exec1( lcd#CMD_PIXELOUT, col )

dat
  word
initSeq
  word $000c, $0005, $0005, $0005, $0002, $0001, $0028, $0000

initData
  word $0000, $0100
  word $0100, $0000
  word $0200, $0107
  word $0300, $20C0
  word $0400, $0000
  word $0800, $0702
  word $0900, $0000
  word $0a00, $0000
  word $0c00, $0000
  word $0d00, $0000
  word $0f00, $0000
  word $0700, $0101

  word $1000, $B010
  word $1100, $0700
  word $0700, $0100
  word $1200, $3B01
  word $1300, $000B

  word $2900, $1200
  word $2A00, $9500

  word $3000, $0a00         
  word $3100, $2613                                            
  word $3200, $290A                                            
  word $3300, $0A29                                            
  word $3400, $1326                                            
  word $3500, $0A0A                                            
  word $3600, $031E                                            
  word $3700, $1E03                                           
  word $3800, $0607                                            
  word $3900, $0303                                            
  word $3A00, $040E                                            
  word $3B00, $010E                                            
  word $3C00, $0E01                                            
  word $3D00, $0E04                                            
  word $3E00, $0303                                            
  word $3F00, $0706                                            
  word $5000, $0000
  word $5100, $EF00
  word $5200, $0000
  word $5300, $3F01
  word $6000, $0027
  word $6100, $0300
  word $6A00, $0000
  word $8000, $0000
  word $8100, $0000
  word $8200, $0000
  word $8300, $0000                                           
  word $8400, $0000                                           
  word $8500, $0000                                           
  word $9000, $1300
  word $9200, $0000                                           
  word $9300, $0301                                           
  word $9500, $1001       
  word $9700, $0000
  word $9800, $0000
  word $f000, $0854
  word $f300, $1000
  word $f400, $1100
  word $f000, $0000
  word $0700, $7301


pub Init | ptr1, ptr2, cont
  ptr1:=0
  ptr2:=0
  cont:=1

  repeat while cont==1
    repeat initSeq[ptr1]
      cmd( initData[ptr2++] )
      data( initData[ptr2++] )

    ptr1++

    if initSeq[ ptr1 ] == 0
      cont:=0
    else
      waitcnt(clkfreq/initSeq[ptr1] + cnt)
       
    ptr1++

  waitcnt(clkfreq/10+cnt)
  
dat
zahl long $1234_5678
printIt long 1
printItAnyway long 0